// functional parallelism with parallel sections (v2)
#include <stdio.h>
#include <unistd.h>
#include <omp.h>


int alpha()			{ sleep(1); return 10;}
int beta()			{ sleep(1); return 20;}
int gama(int a, int b)		{ sleep(1); return a+b;}
int delta()			{ sleep(1); return 40;}
int epsilon(int a, int b)	{ sleep(1); return a-b;}


int main()
{

	double t0 = omp_get_wtime();

	int V = 0, W = 0, X = 0, Y = 0;

	#pragma omp parallel num_threads(2)
	{
		#pragma omp sections
		{
			#pragma omp section
			V = alpha();

			#pragma omp section
			W = beta();
		}

		#pragma omp sections
		{
			#pragma omp section
			Y = delta();

			#pragma omp section
			X = gama(V, W);
		}
	}
	printf("%d\n", epsilon(X,Y));

	double t1 = omp_get_wtime();
	printf("elapsed time = %f s\n", t1-t0);

	return 0;
}



